# Galaxy Project n 7
# 25/02/2017
# DEPIERRE - TARIS

# fastq to BAM
# Bowtie alignement

#!/bin/bash

# Tools path
Bowtie="/usr/local/bioinfo/src/bowtie/bowtie-0.12.9/bowtie"
BowtieBuild="/usr/local/bioinfo/src/bowtie/bowtie-0.12.9/bowtie-build"
SamTools="/usr/local/bioinfo/src/samtools/samtools-1.3.1/samtools"

# GET OPTION
while getopts "f:g:o:h" option
do
case $option in
    f)
        fasta_file=$OPTARG
        ;;
	g)
		genome_ref=$OPTARG
		;;
	o)
		output=$OPTARG
		;;
    \?)
        echo "-f emplacement of fasta files eg:/my/fastq/dir/file.fa"
        echo "-g path to reference genome file eg:/my/genome/dir/myRefGenome.fq.gz"
        echo "-o path to output full name eg:/my/out/dir/outputfile.bam"
        echo "-h Display this help"
        exit 1
        ;;
    h)
        echo "-f emplacement of fasta files eg:/my/fastq/dir/file.fa"
        echo "-g path to reference genome file eg:/my/genome/dir/myRefGenome.fq.gz"
        echo "-o path to output full name eg:/my/out/dir/outputfile.bam"
        echo "-h Display this help"
        ;;
esac
done

#~ fasta_file="/home/ddepierre/work/Galaxy/fasta/cleaned_sequences.fa"
#~ genome_ref="/home/ddepierre/work/Galaxy/genomeRef/genome.fa.gz"
#~ output="/home/ddepierre/work/Galaxy/fasta/fasta.aligned.filt.sort.bam"

# Get path/to/file/prefixName
genome_idx=`echo $genome_ref| cut -d . -f 1`
fasta_name=`echo $fasta_file | cut -d . -f 1`

#~ genome_fq=${genome_idx}.fq
gunzip -c ${genome_ref} > ${genome_idx}.fa
awk '/^>/{print ">chr" ++i; next}{print}' < ${genome_idx}.fa > ${genome_idx}_.fa

${BowtieBuild} ${genome_idx}_.fa ${genome_idx}
${Bowtie} --threads 8 -k 1 -S -f -t ${genome_idx} ${fasta_file} ${fasta_name}.aligned.sam

${SamTools} view -bS -F 1540 -q 30 ${fasta_name}.aligned.sam -o ${fasta_name}.align.filt.bam
${SamTools} sort ${fasta_name}.align.filt.bam -o ${output}

#~ bash fasta2BAM.sh -f /home/ddepierre/work/Galaxy/fasta/cleaned_sequences.fa -g /home/ddepierre/work/Galaxy/genomeRef/genome.fa.gz -o /home/ddepierre/work/Galaxy/fasta/fasta.aligned.filt.sort.bam
